<?php
/*
  $Id cm_pi_options_images.php
  v1.1 20160402 Kymation$

  v.1.6
  Copyright (c) 2019, @raiwa Rainer Schmied

  Copyright (c) 2018, G Burton
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_pi_options_images {
    public $version = '1.6';
    public $code = '';
    public $group = '';
    public $title = '';
    public $description = '';
    public $sort_order = 0;
    public $enabled = false;

    public function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_PI_OI_TITLE;
      $this->description = MODULE_CONTENT_PI_OI_DESCRIPTION;

      if ( defined('MODULE_CONTENT_PI_OI_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_PI_OI_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_PI_OI_STATUS == 'True');
      }
    }

    public function execute() {
      global $oscTemplate, $languages_id, $currencies, $product_info, $fr_input, $fr_required;
        
      $content_width = (int)MODULE_CONTENT_PI_OI_CONTENT_WIDTH;
      $options_output = null;
        
      $products_options_name_query = tep_db_query("select distinct popt.products_options_id, popt.products_options_name from products_options popt, products_attributes patrib where patrib.products_id='" . (int)$_GET['products_id'] . "' and patrib.options_id = popt.products_options_id and popt.language_id = '" . (int)$languages_id . "' order by popt.products_options_name");

      if (tep_db_num_rows($products_options_name_query)) {
        while ($products_options_name = tep_db_fetch_array($products_options_name_query)) {          
          $products_options_array = array();

          $products_options_array = array();
          
          $fr_input = $fr_required = null;
          if (MODULE_CONTENT_PI_OI_ENFORCE == 'True') {
            $fr_input    = FORM_REQUIRED_INPUT;
            $fr_required = 'required aria-required="true" '; 
          }
          if (MODULE_CONTENT_PI_OI_HELPER == 'True') {
            $products_options_array[] = array('id' => '', 'text' => MODULE_CONTENT_PI_OI_ENFORCE_SELECTION);            
          }

          $products_options_query = tep_db_query("select pov.products_options_values_id, pov.products_options_values_name, pov.products_options_values_image, pa.options_values_price, pa.price_prefix, pa.option_image from products_attributes pa, products_options_values pov where pa.products_id = '" . (int)$_GET['products_id'] . "' and pa.options_id = '" . (int)$products_options_name['products_options_id'] . "' and pa.options_values_id = pov.products_options_values_id and pov.language_id = '" . (int)$languages_id . "'");            
          while ($products_options = tep_db_fetch_array($products_options_query)) {             
            $products_options_array[] = array('id' => $products_options['products_options_values_id'], 
                                            'text' => $products_options['products_options_values_name'],
                                            'image' => (tep_not_null($products_options['option_image'])? $products_options['option_image'] : $products_options['products_options_values_image']));
            
            if ($products_options['options_values_price'] != '0') {
              $products_options_array[sizeof($products_options_array)-1]['text'] .= ' (' . $products_options['price_prefix'] . $currencies->display_price($products_options['options_values_price'], tep_get_tax_rate($product_info['products_tax_class_id'])) .') ';
            }
          } //eof while $products_options

          if (is_string($_GET['products_id']) && isset($cart->contents[$_GET['products_id']]['attributes'][$products_options_name['products_options_id']])) {
            $selected_attribute = $cart->contents[$_GET['products_id']]['attributes'][$products_options_name['products_options_id']];
          } else {
            $selected_attribute = false;
          }

          $options_output .= '<div class="form-group row">' . PHP_EOL;
            $options_output .= '<label for="input_' . $products_options_name['products_options_id'] . '" class="col-form-label col-sm-3 text-left text-sm-right">' . $products_options_name['products_options_name'] . '</label>' . PHP_EOL;
            $options_output .= '<div class="col-sm-9">' . PHP_EOL;
              $options_output .= options_images_pull_down_menu('id[' . $products_options_name['products_options_id'] . ']', $products_options_array, $selected_attribute, $fr_required . 'id="input_' . $products_options_name['products_options_id'] . '"') . PHP_EOL;
              $options_output .= $fr_input;
            $options_output .= '</div>' . PHP_EOL;
          $options_output .= '</div>' . PHP_EOL;
        
        }
        ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        $template = ob_get_clean();

        $oscTemplate->addContent($template, $this->group);
      }
    }

    public function isEnabled() {
      return $this->enabled;
    }

    public function check() {
      return defined('MODULE_CONTENT_PI_OI_STATUS');
    }

    public function install() {     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ( 'Module Version', 'MODULE_CONTENT_PI_OI_VERSION', '" . $this->version . "', 'The version of this module that you are running', '6', '0', 'tep_cfg_disabled(', now() ) ");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Options Images Module', 'MODULE_CONTENT_PI_OI_STATUS', 'True', 'Should the product options with images block be shown on the product info page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_PI_OI_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '1', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_PI_OI_SORT_ORDER', '80', 'Sort order of display. Lowest is displayed first.', '6', '2', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Add Helper Text', 'MODULE_CONTENT_PI_OI_HELPER', 'True', 'Should first option in dropdown be Helper Text?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enforce Selection', 'MODULE_CONTENT_PI_OI_ENFORCE', 'True', 'Should customer be forced to select option(s)?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Uninstall Removes Database entries', 'MODULE_CONTENT_PI_OI_REMOVE_DATA', 'False', 'Do you want to remove the options images database column in the products_attributes table when uninstall the module? All your existing options images entries will be lost, use this option only it you are sure that you will not use options images any more.', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      // ADDED FIELDS
      if (tep_db_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_image'")) != 1 ) {
        tep_db_query("AlTER TABLE products_attributes ADD option_image varchar(127) NULL default NULL");
        tep_db_query("ALTER TABLE products_attributes ADD sort_order int(11) NOT NULL default 0");
      }
      // ADD FIELD for options values images
      if (tep_db_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_image'")) != 1 ) {
        tep_db_query("AlTER TABLE products_options_values ADD products_options_values_image varchar(127) NULL default NULL");
      }
      
      // Create image directory for options images
      if(!is_dir(DIR_FS_CATALOG_IMAGES . 'options/'))mkdir(DIR_FS_CATALOG_IMAGES . 'options/', 0755);
      
    }

    public function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      // DELETE ADDED FIELDS
      if ( defined('MODULE_CONTENT_PI_OI_REMOVE_DATA') && MODULE_CONTENT_PI_OI_REMOVE_DATA == 'True' ) {
        tep_db_query("ALTER TABLE products_options_values DROP COLUMN products_options_values_image");
        tep_db_query("ALTER TABLE products_attributes DROP COLUMN option_image");
        tep_db_query("ALTER TABLE products_attributes DROP COLUMN sort_order");
      }
	  }

    public function keys() {
      $keys = array();
      
      $keys[] = 'MODULE_CONTENT_PI_OI_VERSION';
      $keys[] = 'MODULE_CONTENT_PI_OI_STATUS';
      $keys[] = 'MODULE_CONTENT_PI_OI_CONTENT_WIDTH';
      $keys[] = 'MODULE_CONTENT_PI_OI_SORT_ORDER';
      $keys[] = 'MODULE_CONTENT_PI_OI_HELPER';
      $keys[] = 'MODULE_CONTENT_PI_OI_ENFORCE';
      $keys[] = 'MODULE_CONTENT_PI_OI_REMOVE_DATA';
      
      return $keys;
    }
}


  ////////////////////////////////////////////////////////////////////////////
  //                                                                        //
  //  This is the end of the module class.                                  //
  //  Everything past this point is an independent function, not a method.  //
  //                                                                        //
  ////////////////////////////////////////////////////////////////////////////


  ////
  // Function to show a disabled entry (Value is shown but cannot be changed)
  if( !function_exists( 'tep_cfg_disabled' ) ) {
    function tep_cfg_disabled( $value ) {
      return tep_draw_input_field( 'configuration_value', $value, ' disabled' );
    }
  }


////
// Output a form pull down menu for Option Images BS
  function options_images_pull_down_menu($name, $values, $default = '', $parameters = '') {

    $field = '<select name="' . tep_output_string($name) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= ' class="form-control selectpicker" data-width="85%">';

    if (empty($default) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $default = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $default = stripslashes($_POST[$name]);
      }
    }

    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
      if ($default == $values[$i]['id']) {
        $field .= ' selected="selected"';
      }

	   $option_name = tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;'));
	     
	   if( tep_not_null( $values[$i]['image'] ) ) {
	     $field .= ' data-content=\'' . tep_image('images/options/' . $values[$i]['image'], $option_name, '30', '30', null, 'false') . '&nbsp;' . $option_name . '\'';
	   }
	  
	   $field .= '>' . $option_name . '</option>';
    }

    $field .= '</select>';

    return $field;
  }  